SystemOrganization addCategory: #'Mason-Examples'!

MDProduct subclass: #MDDistProduct
	instanceVariableNames: 'package version'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mason-Examples'!

!MDDistProduct class methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2009 09:43'!
build: anArray
	^ (self version: anArray) build! !

!MDDistProduct class methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2009 09:43'!
version: anArray
	^ self basicNew initializeWithVersion: anArray! !

!MDDistProduct methodsFor: 'accessing' stamp: 'cwp 12/13/2009 09:35'!
archiveName
	^ String streamContents:
		[:out |
		out nextPutAll: self releaseName.
		out nextPut: $-.
		(version first: 3)
			do: [:number | out print: number]
			separatedBy: [out nextPut: $.].
		out nextPutAll: '.sar']! !

!MDDistProduct methodsFor: 'as yet unclassified' stamp: 'cwp 1/31/2010 21:26'!
infoClassName
	self subclassResponsibility ! !

!MDDistProduct methodsFor: 'installer content' stamp: 'cwp 12/13/2009 10:25'!
initVersion: anArray for: aClassName on: out 
	out
		nextPutAll: aClassName;
		nextPutAll: ' currentVersion: ';
		print: anArray;
		nextPut: $.! !

!MDDistProduct methodsFor: 'installer content' stamp: 'cwp 1/31/2010 21:25'!
initVersion: anArray  on: out 
	self initVersion: anArray for: self infoClassName on: out! !

!MDDistProduct methodsFor: 'initialize-release' stamp: 'cwp 12/13/2009 09:37'!
initializeWithVersion: anArray
	version := anArray! !

!MDDistProduct methodsFor: 'accessing' stamp: 'cwp 12/13/2009 09:32'!
installerContent
	self subclassResponsibility! !

!MDDistProduct methodsFor: 'accessing' stamp: 'cwp 12/13/2009 09:32'!
readMeContents
	self subclassResponsibility! !

!MDDistProduct methodsFor: 'accessing' stamp: 'cwp 12/13/2009 09:34'!
repository
	^MCHttpRepository
		location: 'http://source.wiresong.ca/mc'
		user: ''
		password: ''	! !

!MDDistProduct methodsFor: 'specifying' stamp: 'cwp 12/13/2009 09:38'!
specifyOn: targets 
	targets zip
		name: self archiveName;
		with: 
			[self specifyContentsOn: targets.
			targets file
				name: 'README';
				content: self readMeContents.
			targets directory
				name: 'install';
				with: 
					[targets file
						name: 'preamble';
						content: self installerContent]]! !

!MDDistProduct methodsFor: 'installer content' stamp: 'cwp 12/13/2009 10:01'!
writeOpenReadmeOn: out 
	^ out
		nextPutAll: 'self openTextFile: ''README''.';
		cr! !

MDDistProduct subclass: #MDFilesystemDistProduct
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mason-Examples'!

!MDFilesystemDistProduct class methodsFor: 'as yet unclassified' stamp: 'cwp 1/31/2010 21:44'!
releases
	^ Dictionary new
		at: #(1 0 0 0) put: 'cwp.53';
		yourself! !

!MDFilesystemDistProduct methodsFor: 'installer content' stamp: 'cwp 1/31/2010 22:16'!
fileInMember: memberName on: out 
	out
		nextPutAll: 'self fileInMemberNamed: ';
		print: memberName! !

!MDFilesystemDistProduct methodsFor: 'accessing' stamp: 'cwp 12/13/2009 09:58'!
infoClassName
	^ 'FSReleaseInfo'! !

!MDFilesystemDistProduct methodsFor: 'initialize-release' stamp: 'cwp 12/13/2009 09:37'!
initializeWithVersion: anArray 
	super initializeWithVersion: anArray.
	package := MDMc1LatestProduct new
		packageName: 'Filesystem';
		repository: self repository;
		yourself.
! !

!MDFilesystemDistProduct methodsFor: 'installer content' stamp: 'cwp 1/31/2010 22:03'!
installerContent
	^ String streamContents: 
		[ :out | 
		self writeInstallOn: out.
		self initVersion: version on: out.
		out cr.
		self writeOpenReadmeOn: out ]! !

!MDFilesystemDistProduct methodsFor: 'accessing' stamp: 'cwp 1/31/2010 22:35'!
readMeContents
	^ self readMeContents101! !

!MDFilesystemDistProduct methodsFor: 'accessing' stamp: 'cwp 1/31/2010 22:35'!
readMeContents100
	^ 'This is the first release of Filesystem, an alternate interface for dealing with files and directories. The interface offers: 
	- Convient path manipulation
	- Transparent access to the contents of zip files
	- Late-bound references to files and directories
	- Robust support for working with entire directory trees
	
More information about how to use the Filesystem API is available at the following URL:

http://www.wiresong.ca/filesystem/

'! !

!MDFilesystemDistProduct methodsFor: 'accessing' stamp: 'cwp 1/31/2010 22:35'!
readMeContents101
	^ 'This is a bugfix release of Filesystem. Changes since Filesystem 1.0.0 include:
	
	- Added convenience methods for Windows drives (suggestion from Eliot Miranda)
	- Fixed bug in resolving the user''s home directory (Andreas Raab)
	- Fixed bug in printing the root directory on Windows
	- Disks on Windows are now listed in alphabetical order
	- Renamed utility methods for converting strings. (suggested by Julian Fitzell)
	- Implemented FSReference class>>roots to allow discovery of fileystems.
	- Implemented a resolver for Unix. (Patrick Shouse)
	- Fixed a bug that would prevent streams from being flushed when closed.
	- Fixed a bug in writing ZipFilesystem contents to the underlying zip file.
	- Fixed a bug in copying directory trees specified with a relative path.
	- Fixed a bug in growing the file allocation when writing to a file in a memory filesystem.
	
More information about how to use the Filesystem API is available at the following URL:

http://www.wiresong.ca/filesystem/

'! !

!MDFilesystemDistProduct methodsFor: 'accessing' stamp: 'cwp 12/13/2009 09:33'!
releaseName
	^ 'Filesystem'! !

!MDFilesystemDistProduct methodsFor: 'specifying' stamp: 'cwp 1/31/2010 21:57'!
specifyContentsOn: targets 
	| update |
	package specifyOn: targets.
	update := self update1001.
	targets file
		name: update basename;
		reference: update! !

!MDFilesystemDistProduct methodsFor: 'accessing' stamp: 'cwp 1/31/2010 22:59'!
update1001
	^ FSLocator image parent  / 'updates' / 'Filesystem-v100-v101.cs'! !

!MDFilesystemDistProduct methodsFor: 'installer content' stamp: 'cwp 1/31/2010 22:18'!
writeInstallOn: out 
	| full |
	full := FSPath * package latestVersion last withExtension: 'st'.
	out
		nextPutAll: '(Smalltalk hasClassNamed: ''';
		nextPutAll: self infoClassName;
		nextPutAll: ''')';
		cr; tab; nextPutAll: 'ifFalse: ['.
	self fileInMember: full basename on: out.
	out 
		nextPut: $];
		cr; tab; nextPutAll: 'ifTrue:';
		cr; tab; tab; nextPut: $[.

	self 
		writeUpdateFrom: #(1 0 0 0 )
		with: self update1001 basename
		on: out.
		
	out 
		nextPutAll: '].';
		cr
	! !

!MDFilesystemDistProduct methodsFor: 'installer content' stamp: 'cwp 1/31/2010 22:08'!
writeUpdateFrom: anArray with: memberName on: out
	out
		nextPut: $(;
		nextPutAll: self infoClassName;
		nextPutAll: ' current version = ';
		print: anArray;
		nextPutAll: ') ifTrue: ['.
	self fileInMember: memberName on: out.
	out nextPut: $]! !

MDDistProduct subclass: #MDMasonDistProduct
	instanceVariableNames: 'umbrella'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mason-Examples'!

!MDMasonDistProduct methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2009 09:05'!
fileIn: name on: out
	out 
		nextPutAll: 'self fileInMemberNamed: ''';
		nextPutAll: name;
		nextPutAll: '.st''.'! !

!MDMasonDistProduct methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2009 09:40'!
initializeWithVersion: anArray
	super initializeWithVersion: anArray.
	umbrella := MDUmbrellaProduct new
		repository: self repository;
		packageName: 'Mason-Umbrella';
		dependencyPackageNames: self packageNames;
		yourself! !

!MDMasonDistProduct methodsFor: 'as yet unclassified' stamp: 'cwp 1/31/2010 21:26'!
installerContent
	| names filesystem mason |
	names := umbrella customizedVersionNames.
	filesystem := names detect: [ :ea | ea beginsWith: 'Filesystem' ].
	mason := names reject: [ :ea | ea beginsWith: 'Filesystem' ].
	^ String streamContents: 
		[ :out | 
		self on: out ifFilesystem: 
			[self fileIn: filesystem on: out.
			out cr; tab.
			self initVersion: FSReleaseInfo current version on: out].
		out cr.
		mason do: 
			[ :name | 
			self fileIn: name on: out.
			out cr ].
		out cr.
		self initVersion: version for: 'MDMasonReleaseInfo' on: out.
		out cr.
		self writeOpenReadmeOn: out]! !

!MDMasonDistProduct methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2009 10:39'!
on: out ifFilesystem: aBlock 
	out
		nextPutAll: '(Smalltalk hasClassNamed: ''FSReleaseInfo'') ifFalse: ';
		cr; tab;
		nextPut: $[.
	aBlock value.
	out 
		nextPut: $];
		nextPut: $.;
		cr! !

!MDMasonDistProduct methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2009 09:19'!
packageNames
	^ #('Filesystem' 'Mason-Core' 'Mason-MC1' 'Mason-Metacello' 'Mason-Examples')! !

!MDMasonDistProduct methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2009 09:47'!
readMeContents
	^ 'This is Mason, a build system for Squeak. 
	
Mason is capable of building images that do not include Mason its self. This relies on OSProcess which is available at the following URL: 

	http://wiki.squeak.org/squeak/708
	
'! !

!MDMasonDistProduct methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2009 09:42'!
releaseName
	^ 'Mason'! !

!MDMasonDistProduct methodsFor: 'as yet unclassified' stamp: 'cwp 12/13/2009 09:44'!
specifyContentsOn: targets
	targets specify: umbrella.! !
